<!--
  -  Copyright 2020 Huawei Technologies Co., Ltd.
  -
  -  Licensed under the Apache License, Version 2.0 (the "License");
  -  you may not use this file except in compliance with the License.
  -  You may obtain a copy of the License at
  -
  -      http://www.apache.org/licenses/LICENSE-2.0
  -
  -  Unless required by applicable law or agreed to in writing, software
  -  distributed under the License is distributed on an "AS IS" BASIS,
  -  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  -  See the License for the specific language governing permissions and
  -  limitations under the License.
  -->

<template>
  <div>
    <div class="pageTitle">
      <el-row>
        <div class="el-row-button-input">
          <label>
            {{ $t('nav.listofauthapplications') }}
          </label>
          <el-button
            id="batchDltBtn"
            style="float:right;"
            type="primary"
            @click="dialogVisible = true"
          >
            <em class="el-icon-edit" />
            Go to Certification
          </el-button>
        </div>
      </el-row>
    </div>
    <div class="userList">
      <SearchResource
        :applicant-item="false"
        :status-item="false"
        :lab-item="false"
        @getSearchData="getCeritificationDataList"
      />
      <div class="tableDiv">
        <el-row>
          <el-col
            :span="24"
            class="table"
          >
            <el-table
              v-loading="dataLoading"
              :data="certifyDataList"
              border
            >
              <el-table-column
                prop="name"
                :label="$t('env.name')"
              />
              <el-table-column
                prop="scenario"
                :label="$t('env.scenario')"
              />
              <el-table-column
                prop="architecture"
                :label="$t('env.architecture')"
              />
              <el-table-column
                prop="specifications"
                :label="$t('env.specifications')"
              />
              <el-table-column
                prop="developer"
                :label="$t('env.developer')"
              />
              <el-table-column
                prop="description"
                :label="$t('env.description')"
              />
            </el-table>
          </el-col>
        </el-row>
        <el-dialog
          :title="$t('user.addUsrBtn')"
          :visible.sync="dialogVisible"
          v-loading="loading"
        >
          <div style="margin-top: 15px;">
            <el-input
              :placeholder="$t('env.applicationName')"
              type="text"
              v-model="currentRowData.name"
            />
          </div>
          <div style="margin-top: 15px;">
            <el-input
              :placeholder="$t('env.scenario')"
              type="text"
              v-model="currentRowData.scenario"
            />
          </div>
          <div style="margin-top: 15px;">
            <el-input
              :placeholder="$t('env.architecture')"
              type="text"
              v-model="currentRowData.architecture"
            />
          </div>
          <div style="margin-top: 15px;">
            <el-input
              :placeholder="$t('env.specifications')"
              type="text"
              v-model="currentRowData.specifications"
            />
          </div>
          <div style="margin-top: 15px;">
            <el-input
              :placeholder="$t('env.developer')"
              type="text"
              v-model="currentRowData.developer"
            />
          </div>
          <div style="margin-top: 15px;">
            <el-input
              :placeholder="$t('env.description')"
              type="text"
              v-model="currentRowData.description"
            />
          </div>
          <div
            slot="footer"
            class="dialog-footer"
          >
            <el-button
              id="cancelBtn"
              @click="cancel()"
            >
              {{ $t('common.cancel') }}
            </el-button>
            <el-button
              id="confirmBtn"
              type="primary"
              @click="addCertificate()"
              :loading="loading"
            >
              {{ $t('common.confirm') }}
            </el-button>
          </div>
        </el-dialog>
      </div>
    </div>
  </div>
</template>

<script>
import SearchResource from '../../components/SearchResource.vue'
import axios from 'axios'
import { BASE_URL } from '../../tools/constant.js'
export default {
  name: 'AppRequests',
  components: {
    SearchResource
  },
  data () {
    return {
      dataLoading: true,
      certifyDataList: [],
      dialogVisible: false,
      currentRowData: {},
      loading: false,
      dialogLoading: false
    }
  },
  mounted () {
    this.getCeritificationDataList()
  },
  computed: {
  },
  methods: {
    async getCeritificationDataList (data) {
      if (!data) {
        data = {
          name: ''
        }
      }
      let url = BASE_URL + '/getAuthenticatedApplication?name=' + data.name
      axios({
        method: 'GET',
        url: url
      }).then(res => {
        this.certifyDataList = res.data
        this.dataLoading = false
      }, error => {
        if (error) {
          this.$parent.errorMessage(this.$t(error.response.data))
          this.dataLoading = false
        }
      })
    },
    addCertificate () {
      this.currentRowData['userId'] = sessionStorage.getItem('userId')
      let url = BASE_URL + '/addAuthenticatedApplication'
      axios({
        method: 'POST',
        data: this.currentRowData,
        url: url
      }).then(res => {
        this.dataLoading = false
        this.cancel()
        this.getCeritificationDataList()
      }, error => {
        if (error) {
          this.$parent.errorMessage(this.$t(error.response.data))
          this.dataLoading = false
        }
      })
    },
    async getMyRequest () {
    },
    cancel () {
      this.dialogVisible = false
    },
    async confirm () {
      this.cancel()
    }
  }
}
</script>

<style lang='less' scoped>
.pageTitle {
  margin: 5% 2% 1% 2%;
  font-weight: bold;
}
.userList {
    margin: 0 2%;
    height: 100%;
    background: #fff;
    padding: 30px 0px;
  .tableDiv {
    width: 100%;
  }
  .el-row-button-input {
    margin-top: 10px;
    height:40px;
  }
  .table {
    margin-top: 15px;
  }
  .el-row-table {
    margin-top: 10px;
  }
  .shortdesc{
    overflow: hidden;
    text-overflow: ellipsis;
    display:-webkit-box;
    -webkit-box-orient:vertical;
    -webkit-line-clamp:2;
  }
}
</style>
